//
// This file is part of the Marble Virtual Globe.
//
// This program is free software licensed under the GNU LGPL. You can
// find a copy of this license in LICENSE.txt in the top directory of
// the source code.
//
// Copyright 2012      Dennis Nienhüser <earthwings@gentoo.org>
//

//#include <marble/MarbleWidget.h>
//#include <marble/MarbleMap.h>
//#include <marble/MarbleModel.h>
//#include <marble/GeoPainter.h>
//#include <marble/GeoDataLineString.h>
#include <marble/LayerInterface.h>
//#include <marble/ViewportParams.h>

#include "test.h"

#include <QObject>

using namespace Marble;

namespace Marble
{
   class GeoDataCoordinates;
   class MarbleWidget;
};

class MyPaintLayer : public QObject, public LayerInterface
{
public:
    // Constructor
    MyPaintLayer(MarbleWidget* widget);

    // Implemented from LayerInterface
    virtual QStringList renderPosition() const;

    // Implemented from LayerInterface
    virtual bool render( GeoPainter *painter, ViewportParams *viewport,
       const QString& renderPos = "NONE", GeoSceneLayer * layer = 0 );

    // Overriding QObject
    virtual bool eventFilter(QObject *obj, QEvent *event);

    void setBrushEnabled(bool enabled)
    { m_brushEnabled = enabled; }

    void setCenter(const GeoDataCoordinates &);

    static GeoDataCoordinates approximate(const GeoDataCoordinates &base, qreal angle, qreal dist);

private:
    MarbleWidget* m_widget;

    int m_index;
    int m_opacity;
    bool m_brushEnabled;
    GeoDataCoordinates * m_center;
};

